/*
 * CornBucket - a simple grain maker
 * CBDialog.c
 * HandleLengthDialog() - get the note length and call
 * HandleCBDialog() - set all parameters
 */

#include "Dialog.h"
#include "CB.h"

extern DialogPtr	gAboutDialog, gErrorDialog, gCBDialog, gLengthDialog, gFunctionDialog;
float	*gFrequency, *gDeviation, *gDensity, *gAmplitude, 
		*gPanning, *gWaveform, *gDuration;
double	gLengthGrain;
Boolean	gDurFreq;
extern long	controlCycleNumber;	/* is equal to 1/10 millisecond */
extern Boolean gMakingNotes;
Str255 gScoreName;
short	gScoreVRefNum, gScoreDFileNum;

void
HandleLengthDialog()
{
	short		itemType, itemHit;
	Handle	itemHandle;
	Rect	itemRect;
	int		dialogDone = FALSE;
	Str255	lengthStr;
	
	gLengthGrain = 3.0000;
	GetDItem(gLengthDialog, L_LENGTH_FIELD, &itemType, &itemHandle, &itemRect);
	SetIText(itemHandle, "\p3.000000");
	SelectWindow(gLengthDialog);
	DrawDialog(gLengthDialog);
	ShowWindow(gLengthDialog);
	DrawOKOutline(gLengthDialog);
	while(dialogDone == FALSE)
	{
		ModalDialog(NIL_POINTER,&itemHit);
		switch(itemHit)
		{
			case L_OK_BUTTON:
				HideWindow(gLengthDialog);
				dialogDone = TRUE;
				HandleCBDialog();
				break;
			case L_CANCEL_BUTTON:
				HideWindow(gLengthDialog);
				dialogDone = TRUE;
				break;
			case L_LENGTH_FIELD:
				GetDItem(gLengthDialog,PH_FIELD, &itemType, &itemHandle, &itemRect);
				GetIText(itemHandle,lengthStr);
				StringToFix(lengthStr, &gLengthGrain);
				break;
			default:
				break;
		}
	}
}

void
HandleCBDialog(void)
{
	short	i, itemType, itemHit, returnValue;
	Handle	itemHandle;
	Rect	itemRect;
	int		dialogDone = FALSE;
	SFReply	reply;
	Str255	lengthStr;
	Point	myPoint;
	OSErr	error;
	unsigned long seconds;

	gFrequency = (float *)NewPtr(400L * sizeof(float));
	gDeviation = (float *)NewPtr(400L * sizeof(float));
	gDensity = (float *)NewPtr(400L * sizeof(float));
	gPanning = (float *)NewPtr(400L * sizeof(float));
	gAmplitude = (float *)NewPtr(400L * sizeof(float));
	gWaveform = (float *)NewPtr(400L * sizeof(float));
	gDuration = (float *)NewPtr(400L * sizeof(float));
	
	GetDateTime(&seconds);
	qd.randSeed = seconds;
	GetDItem(gCBDialog, A_DURFREQ_BOX, &itemType, &itemHandle, &itemRect);
	SetCtlValue((ControlHandle)itemHandle,OFF);
	gDurFreq = FALSE;
	
	for(i = 0; i < 400; i++)
	{
		*(gFrequency + i) = 1000.0;
		*(gDeviation + i) = 100.0;
		*(gDensity + i) = 50.0;
		*(gPanning + i) = 0.5;
		*(gAmplitude + i) = 50.0;
		*(gWaveform + i) = 0.5;
		*(gDuration + i) = 3.0;
	}
	
	SelectWindow(gCBDialog);
	DrawDialog(gCBDialog);
	ShowWindow(gCBDialog);
	DrawOKOutline(gCBDialog);
	while(dialogDone == FALSE)
	{
		ModalDialog(NIL_POINTER,&itemHit);
		switch(itemHit)
		{
			case A_OK_BUTTON:
				HideWindow(gCBDialog);
				controlCycleNumber = 0;	/* is equal to 1/10 millisecond */
				gMakingNotes = TRUE;
				SetDAFont(systemFont);
				myPoint.h = 100;
				myPoint.v = 100;
				SFPutFile(myPoint,"\pSave ScoreFile as:","\ptest.sco", NIL_DIALOG_HOOK, &reply);
				if(reply.good == FALSE)
					break;
				for(i=0;i<=reply.fName[0];i++)
					gScoreName[i]=reply.fName[i];
				gScoreVRefNum = reply.vRefNum;
				SetVol((StringPtr)NIL_POINTER, gScoreVRefNum);
				/* Try to open to see if file exists */
				error = FSOpen(gScoreName, gScoreVRefNum, &gScoreDFileNum);
				if(error == noErr)
				{
					FSClose(gScoreDFileNum);
					FlushVol((StringPtr)NIL_POINTER,gScoreVRefNum);
					FSDelete(gScoreName, gScoreVRefNum);
				}
				Create(gScoreName, gScoreVRefNum, 'CBte', 'TEXT');
				FSOpen(gScoreName, gScoreVRefNum, &gScoreDFileNum);
				dialogDone = TRUE;
				break;
			case A_CANCEL_BUTTON:
				HideWindow(gCBDialog);
				dialogDone = TRUE;
				break;
			case A_DURFREQ_BOX:
				GetDItem(gCBDialog, A_DURFREQ_BOX, &itemType, &itemHandle, &itemRect);
				if(GetCtlValue((ControlHandle)itemHandle) == TRUE)
				{
					SetCtlValue((ControlHandle)itemHandle,OFF);
					gDurFreq = FALSE;
					ShowDItem(gCBDialog, A_DURAT_BUTTON);
				} else
				{
					SetCtlValue((ControlHandle)itemHandle,ON);
					gDurFreq = TRUE;
					HideDItem(gCBDialog, A_DURAT_BUTTON);
				}
				break;
			case A_FREQU_BUTTON:
				HandleDrawFunctionDialog(gFrequency, 20000.0, 0.0, "\pFrequency","\pRange: 0 - 20000 Hz", gLengthGrain);
				break;
			case A_DEVIA_BUTTON:
				HandleDrawFunctionDialog(gDeviation, 1000.0, 0.0, "\pDeviation","\pRange: 0 - 1000 Hz", gLengthGrain);
				break;
			case A_DENSI_BUTTON:
				HandleDrawFunctionDialog(gDensity, 100.0, 0.0, "\pDensity","\pRange: 0 - 100%", gLengthGrain);
				break;
			case A_AMPLI_BUTTON:
				HandleDrawFunctionDialog(gAmplitude, 100.0, 0.0, "\pAmplitude","\pRange: 0 - 100%", gLengthGrain);
				break;
			case A_PANNI_BUTTON:
				HandleDrawFunctionDialog(gPanning, 1.0, 0.0, "\pPanning","\pLeft = 0, Right = 1", gLengthGrain);
				break;
			case A_WAVEF_BUTTON:
				HandleDrawFunctionDialog(gWaveform, 1.0, 0.0, "\pWave Mix","\pSine = 0, Pulse = 1", gLengthGrain);
				break;
			case A_DURAT_BUTTON:
				HandleDrawFunctionDialog(gDuration, 10000.0, 1.0, "\pDuration","\pRange: 1 - 10000 mSec", gLengthGrain);
				break;
			default:
				break;
		}
	}
}