/* 
 *	CornBucket - simple granual score generator
 *
 *  Dialog.c - ancillary dialog routines.
 *
 *	Copyright 1994 Tom Erbe - CalArts
 */

#include <math.h>
#include "Dialog.h"
#include "CB.h"


extern DialogPtr	gAboutDialog, gErrorDialog;
extern MenuHandle	gTypeMenu, gFormatMenu;
extern WindowPtr	gNoteWindow;
extern RgnHandle	gNoteRegion;

void
DrawErrorMessage(s)
Str255	s;
{
	short	itemHit, itemType;
	Handle	itemHandle;
	Rect	itemRect;
	int	dialogDone = FALSE;
	
	GetDItem(gErrorDialog, ERROR_TEXT, &itemType, &itemHandle, &itemRect);
	SetIText(itemHandle, s);
	SelectWindow(gErrorDialog);
	DrawDialog(gErrorDialog);
	ShowWindow(gErrorDialog);
	DrawOKOutline(gErrorDialog);
	while(dialogDone == FALSE)
	{
		ModalDialog(NIL_POINTER,&itemHit);
		switch(itemHit)
		{
			case ERROR_OK:
				HideWindow(gErrorDialog);
				dialogDone = TRUE;
				break;
			default:
				break;
		}
	}
}

void
ShowNote(Str255	s)
{
	short	itemHit, itemType;
	Handle	itemHandle;
	Rect	myRect;
	
	SelectWindow(gNoteWindow);
	ShowWindow(gNoteWindow);
	SetPort(gNoteWindow);
	myRect = gNoteWindow->portRect;
	TextFont(monaco);
	TextSize(10);
	ScrollRect(&myRect,0,-12,gNoteRegion);
	FillRgn(gNoteRegion,&(qd.white));
	MoveTo(myRect.left + 5, myRect.bottom - 5);
	DrawString(s);
}

void
HandleAboutDialog()
{
	short	itemHit;
	int		dialogDone = FALSE;
	
	DrawDialog(gAboutDialog);
	ShowWindow(gAboutDialog);
	SelectWindow(gAboutDialog);

	while(dialogDone == FALSE)
	{
		ModalDialog(NIL_POINTER,&itemHit);
		switch(itemHit)
		{
			case 1:
				HideWindow(gAboutDialog);
				dialogDone = TRUE;
				break;
			default:
				break;
		}
	}
}

void
DrawOKOutline(theDialog)
DialogPtr	theDialog;
{
	short	itemType;
	Rect	itemRect;
	Handle	itemHandle;
	GrafPtr	oldPort;
	PenState	oldPenState;
	
	GetDItem(theDialog, 1, &itemType, &itemHandle, &itemRect);
	GetPenState(&oldPenState);
	GetPort(&oldPort);
	SetPort(theDialog);
	PenSize(3,3);
	InsetRect(&itemRect, -4, -4);
	FrameRoundRect(&itemRect, 16, 16);
	SetPenState(&oldPenState);
	SetPort(oldPort);
}
