#if __MC68881__
#define __FASTMATH__
#define __HYBRIDMATH__
#endif	/* __MC68881__ */
#include <math.h>
#include "Dialog.h"
#include "CB.h"

#define	SLEEP				0L
#define	NIL_MOUSE_REGION	0L

#define	DRAW_TOP	7
#define	DRAW_BOTTOM	277
#define	DRAW_LEFT	88
#define	DRAW_RIGHT	488

#ifdef powerc
extern ModalFilterUPP	gDrawTrackFilter;
#endif
extern DialogPtr	gFunctionDialog, gPhaseDialog, gSetAllDialog;
extern Boolean		gWNEImplemented;
extern EventRecord	gTheEvent;
extern float		gTwoPi, Pi;
extern double		gLengthGrain;

float gTimeRange;

float
InterpFunctionValue(function, inPosition)
float function[];
long inPosition;
{
	/* 
	 * inPosition - number of frames .001 sec long @ 44100 sps
	 * gGrainLength - length of grain in seconds
	 */
	 
	long intIndex;
	float modIndex, funcIndex, interpValue;
	
	funcIndex = ((float)inPosition * 399.0)/(gLengthGrain*1000);
	intIndex = (long)funcIndex;
	modIndex = funcIndex - (float)intIndex;
	
	
	interpValue = function[intIndex] * (1.0-modIndex) + modIndex * function[intIndex+1];
	if(intIndex >= 399)
		return(function[399]);
	else
		return(interpValue);
}

void
HandleDrawFunctionDialog(float *function, float topRangeMax,float botRangeMax, Str255 labelStr, Str255 legendStr, float timeRange)
{
	short	itemType, itemHit;
	int		i, j, dialogDone=FALSE, drawDone=FALSE, mouseLocOldH = 0,
			mouseLocOldV = 0, shift;
	Handle	itemHandle;
	Str255	topRangeStr, botRangeStr, scaleStr, timeStr, errStr;
	double	topRange, botRange, scale, vPosition, vPositionOld,
			hPosition, hPositionOld, cycle, tmpFloat,
			tmpFloat2, zeroPoint;
	float	floatBlock[400];
	Rect	itemRect, drawRect;
	Point	mouseLoc;
	PenState oldPenState;
	long	blockSize;
	Boolean up = TRUE, initialized = FALSE;
	
	/* Initialize variables */
	
	SetPort(gFunctionDialog);
   	gTimeRange = timeRange;
	topRange = topRangeMax;
	botRange = botRangeMax;
	scale = topRange - botRange;
	zeroPoint = scale/2.0 + botRange;
	cycle = 1.0;
	FixToString(topRange, topRangeStr);
	FixToString(botRange, botRangeStr);
	FixToString(cycle, errStr);

/*	Initialize Dialog */
	
	SetPort(gFunctionDialog);
	GetDItem(gFunctionDialog, DF_TOPRANGE_FIELD, &itemType, &itemHandle, &itemRect);
	SetIText(itemHandle, topRangeStr);
	GetDItem(gFunctionDialog, DF_BOTRANGE_FIELD, &itemType, &itemHandle, &itemRect);
	SetIText(itemHandle, botRangeStr);
	GetDItem(gFunctionDialog, DF_CYCLE_FIELD, &itemType, &itemHandle, &itemRect);
	SetIText(itemHandle, errStr);
	GetDItem(gFunctionDialog, DF_SCALE_LABEL, &itemType, &itemHandle, &itemRect);
	SetIText(itemHandle, labelStr);
	GetDItem(gFunctionDialog, DF_LEGEND_TEXT, &itemType, &itemHandle, &itemRect);
	SetIText(itemHandle, legendStr);
	ShowWindow(gFunctionDialog);
	DrawOKOutline(gFunctionDialog);
	SelectWindow(gFunctionDialog);
	DrawFunction(function, scale, botRange);
	
	while(dialogDone == FALSE)
	{
#ifdef powerc
		ModalDialog((ModalFilterUPP)gDrawTrackFilter,&itemHit);
#else
		ModalDialog((ModalFilterUPP)DrawTrackFilter,&itemHit);
#endif
		switch(itemHit)
		{
			case DF_DONE_BUTTON:
				HideWindow(gFunctionDialog);
				dialogDone = TRUE;
				break;
			case DF_TOPRANGE_FIELD:
				GetDItem(gFunctionDialog,DF_TOPRANGE_FIELD, &itemType, &itemHandle, &itemRect);
				GetIText(itemHandle, topRangeStr);
				StringToFix(topRangeStr, &topRange);
				if(topRange > topRangeMax || topRange < botRange)
				{
					topRange = topRangeMax;
					FixToString(topRange, topRangeStr);
					SetIText(itemHandle,topRangeStr);
				}
				scale = topRange - botRange;
				zeroPoint = scale/2.0 + botRange;
				DrawFunction(function, scale, botRange);
				break;
			case DF_BOTRANGE_FIELD:
				GetDItem(gFunctionDialog,DF_BOTRANGE_FIELD, &itemType, &itemHandle, &itemRect);
				GetIText(itemHandle,botRangeStr);
				StringToFix(botRangeStr, &botRange);
				if(botRange < botRangeMax || botRange > topRange)
				{
					botRange = botRangeMax;
					FixToString(botRange, botRangeStr);
					SetIText(itemHandle, botRangeStr);
				}
				scale = topRange - botRange;
				zeroPoint = scale/2.0 + botRange;
				DrawFunction(function, scale, botRange);
				break;
			case DF_CYCLE_FIELD:
				GetDItem(gFunctionDialog,DF_CYCLE_FIELD, &itemType, &itemHandle, &itemRect);
				GetIText(itemHandle,errStr);
				StringToFix(errStr, &cycle);
				break;
			case DF_RAMP_BUTTON:
				for(i = 0; i < 400; i++)
				{
					tmpFloat = (i*cycle)/800.0;
					while(tmpFloat>.5)
						tmpFloat = tmpFloat - 0.5;
					if(initialized)
						function[i] = (function[i] - zeroPoint)*(1.0 - 2.0*tmpFloat) + zeroPoint;
					else
						function[i] = (((1.0 - tmpFloat) * scale) + botRange);
				}
				DrawFunction(function, scale, botRange);
				initialized = TRUE;
				break;				
			case DF_SAW_BUTTON:
				for(i = 0; i < 400; i++)
				{
					tmpFloat = (i*cycle)/400.0;
					while(tmpFloat>1.0)
						tmpFloat = tmpFloat - 1.0;
					if(initialized)
						function[i] = (function[i]-zeroPoint)*(1.0 - 2.0*tmpFloat)+zeroPoint;
					else
						function[i] = (((1.0 - tmpFloat) * scale) + botRange);
				}
				DrawFunction(function, scale, botRange);
				initialized = TRUE;
				break;				
			case DF_SQUARE_BUTTON:
				tmpFloat = 1.0;
				tmpFloat2 = 0.0;
				for(i = 0; i < 400; i++)
				{
					tmpFloat2 += cycle/400.0;
					if(tmpFloat2 > 0.5)
					{
						tmpFloat2 -= 0.5;
						tmpFloat *= -1.0;
					}
					if(initialized)
						function[i] = (function[i]-zeroPoint)*tmpFloat+zeroPoint;
					else
						function[i] = (((tmpFloat+1.0)/2.0) * scale) + botRange;
				}
				DrawFunction(function, scale, botRange);
				initialized = TRUE;
				break;				
			case DF_TRI_BUTTON:
				up = TRUE;
				tmpFloat = 0.5;
				for(i = 0; i < 400; i++)
				{
					if(up)
					{
						tmpFloat = tmpFloat + cycle/400.0;
						if(tmpFloat>1.0)
						{
							tmpFloat = 2.0 - tmpFloat;
							up = FALSE;
						}
					}
					else
					{
						tmpFloat = tmpFloat - cycle/400.0;
						if(tmpFloat<0.5)
						{
							tmpFloat = 1.0 - tmpFloat;
							up = TRUE;
						}
					}
					if(initialized)
						function[i] = (function[i] - zeroPoint)*(2.0 * (tmpFloat-0.5)) + zeroPoint;
					else
						function[i] = ((tmpFloat * scale) + botRange);
				}
				DrawFunction(function, scale, botRange);
				initialized = TRUE;
				break;				
			case DF_TRIFULL_BUTTON:
				up = TRUE;
				tmpFloat = 0.0;
				for(i = 0; i < 400; i++)
				{
					if(up)
					{
						tmpFloat = tmpFloat + cycle/200.0;
						if(tmpFloat>1.0)
						{
							tmpFloat = 2.0 - tmpFloat;
							up = FALSE;
						}
					}
					else
					{
						tmpFloat = tmpFloat - cycle/200.0;
						if(tmpFloat<0.0)
						{
							tmpFloat = 0.0 - tmpFloat;
							up = TRUE;
						}
					}
					if(initialized)
						function[i] = (function[i]-zeroPoint)*((2.0 * tmpFloat) - 1.0)+zeroPoint;
					else
						function[i] = ((tmpFloat * scale) + botRange);
				}
				DrawFunction(function, scale, botRange);
				initialized = TRUE;
				break;				
			case DF_SINE_BUTTON:
				for(i = 0; i < 400; i++)
				{
					if(initialized)
						function[i] = (function[i] - zeroPoint)*sin(gTwoPi*(i*cycle)/400.0) + zeroPoint;
					else
					{
						tmpFloat = sin(gTwoPi*i*cycle/400.0);
						function[i] = ((tmpFloat+1.0)/2.0 * scale) + botRange;
					}
				}
				DrawFunction(function, scale, botRange);
				initialized = TRUE;
				break;
			case DF_PHASE_BUTTON:
				shift = HandlePhaseDialog();
				if(shift == 0)
				{
					DrawFunction(function, scale, botRange);
					break;
				}
				for(i = 0; i < 400; i++)
					floatBlock[i] = function[i];
				for(i = 0, j = shift; i < 400; i++)
				{
					function[j] = floatBlock[i];
					if(++j == 400)
						j = 0;
				}
				DrawFunction(function, scale, botRange);
				break;
			case DF_REVERSE_BUTTON:
				for(i = 0; i < 400; i++)
					floatBlock[i] = function[i];
				for(i = 0; i < 400; i++)
					function[i] = floatBlock[399 - i];
				DrawFunction(function, scale, botRange);
				break;
			case DF_CLEAR_BUTTON:
				tmpFloat = HandleSetAllDialog();
				for(i = 0; i < 400; i++)
					function[i] = tmpFloat;
				DrawFunction(function, scale, botRange);
				initialized = FALSE;
				break;				
			case DF_INVERT_BUTTON:
				for(i = 0; i < 400; i++)
					function[i] = -function[i] + (topRange + botRange);
				DrawFunction(function, scale, botRange);
				break;				
			case DF_AVG_BUTTON:
				function[0] = (function[399] + function[1])/2.0;
				for(i = 1; i < 399; i++)
					function[i] = (function[i-1] + function[i+1])/2.0;
				function[399] = (function[0] + function[398])/2.0;
				DrawFunction(function, scale, botRange);
				break;				
			case DF_DRAW_PICT:
				drawDone = FALSE;
				PenNormal();
				ShowPen();
				while(drawDone == FALSE)
				{
					if(gWNEImplemented)
						WaitNextEvent(everyEvent, &gTheEvent, SLEEP, NIL_MOUSE_REGION);
					else
					{
						SystemTask();
						GetNextEvent(everyEvent, &gTheEvent);
					}
					switch(gTheEvent.what)
					{
						case mouseUp:
							drawDone = TRUE;
							mouseLocOldH = 0;
							break;
						default:
							GetMouse(&mouseLoc);
							if(mouseLoc.v > DRAW_TOP && mouseLoc.v < DRAW_BOTTOM && 
								mouseLoc.h > DRAW_LEFT && mouseLoc.h < DRAW_RIGHT)
							{
								if(mouseLocOldH == 0)
								{
									mouseLocOldH = mouseLoc.h;
									mouseLocOldV = mouseLoc.v;
								}
								MoveTo(mouseLocOldH,mouseLocOldV);
								LineTo(mouseLoc.h, mouseLoc.v);
								mouseLocOldV = mouseLoc.v;
								vPosition = ((DRAW_BOTTOM - mouseLoc.v) * scale)/270.0 + botRange;
								hPosition = ((mouseLoc.h - DRAW_LEFT) * gTimeRange)/400.0;
								if(mouseLoc.h < mouseLocOldH)
									for(i = mouseLoc.h; i < mouseLocOldH; i++)
										function[i - DRAW_LEFT] = vPosition 
											+ ((vPositionOld-vPosition)*((float)(i-mouseLoc.h)/(mouseLocOldH-mouseLoc.h)));
								else
									for(i = mouseLocOldH; i < mouseLoc.h; i++)
										function[i - DRAW_LEFT] = vPositionOld 
											+ ((vPosition-vPositionOld)*((float)(i-mouseLocOldH)/(mouseLoc.h-mouseLocOldH)));
								mouseLocOldH = mouseLoc.h;
								if(vPosition != vPositionOld)
								{
									vPositionOld = vPosition;
									FixToString(vPosition,scaleStr);
									GetDItem(gFunctionDialog, DF_SCALE_TEXT, &itemType, &itemHandle, &itemRect);
									SetIText(itemHandle, scaleStr);
								}
								if(hPosition != hPositionOld)
								{
									hPositionOld = hPosition;
									FixToString(hPosition,timeStr);
									GetDItem(gFunctionDialog, DF_TIME_TEXT, &itemType, &itemHandle, &itemRect);
									SetIText(itemHandle, timeStr);
								}
								/* Big Fudge */
								function[0] = function[1];
								function[399] = function[398];
							}
							break;
					}
				}
				HidePen();
				initialized = TRUE;
				DrawFunction(function, scale, botRange);
				break;
			default:
				break;
		}
	}
}

void
DrawFunction(function, scale, offset)
float *function;
double scale, offset;
{

	short	itemType, i, vPos;
	Handle	itemHandle;
	Rect 	drawRect,dialogRect, myRect;
	float	test;
	Str255	errStr;
	
	SetPort(gFunctionDialog);
	PenSize(2,2);
	PenMode(patCopy);
	PenPat(&(qd.black));
	ShowPen();
	dialogRect = gFunctionDialog->portRect;
	GetDItem(gFunctionDialog, DF_DRAW_PICT, &itemType, &itemHandle, &drawRect);
	myRect.top = drawRect.top + 2;
	myRect.bottom = drawRect.bottom - 2;
	myRect.left = drawRect.left + 2;
	myRect.right = drawRect.right - 2;
	EraseRect(&myRect);
	ClipRect(&myRect);
	vPos = 276 - (int)(270.0*(function[0]-offset)/scale);
	MoveTo(88, vPos);
	for(i=88; i<488; i++)
	{
		vPos = 276 - (int)(270.0*(function[i-88]-offset)/scale);
		LineTo(i,vPos);
	}
	ShowDItem(gFunctionDialog, DF_DRAW_PICT);
	HidePen();
	ClipRect(&dialogRect);
}

pascal Boolean
DrawTrackFilter(DialogPtr dialogPtr, EventRecord *theEvent, int *itemHit)
{
	short	itemType;
	Handle	itemHandle;
	Str255	topRangeStr, botRangeStr, scaleStr, timeStr, errStr;
	double	topRange, botRange, scale, vPosition, 
			hPosition;
	static	double	hPositionOld, vPositionOld; 
	Rect	itemRect;
	Point	mouseLoc;
	char	character;
				
	GetDItem(gFunctionDialog,DF_TOPRANGE_FIELD, &itemType, &itemHandle, &itemRect);
	GetIText(itemHandle, topRangeStr);
	StringToFix(topRangeStr, &topRange);
	GetDItem(gFunctionDialog,DF_BOTRANGE_FIELD, &itemType, &itemHandle, &itemRect);
	GetIText(itemHandle,botRangeStr);
	StringToFix(botRangeStr, &botRange);
	scale = topRange - botRange;

	GetMouse(&mouseLoc);
	if(mouseLoc.v > DRAW_TOP && mouseLoc.v < DRAW_BOTTOM && 
			mouseLoc.h > DRAW_LEFT && mouseLoc.h < DRAW_RIGHT)
	{
		vPosition = ((DRAW_BOTTOM - mouseLoc.v) * scale)/270.0 + botRange;
		hPosition = ((mouseLoc.h - DRAW_LEFT) * gTimeRange)/400.0;
		if(vPosition != vPositionOld)
		{
			vPositionOld = vPosition;
			FixToString(vPosition,scaleStr);
			GetDItem(gFunctionDialog, DF_SCALE_TEXT, &itemType, &itemHandle, &itemRect);
			SetIText(itemHandle, scaleStr);
		}
		if(hPosition != hPositionOld)
		{
			hPositionOld = hPosition;
			FixToString(hPosition,timeStr);
			GetDItem(gFunctionDialog, DF_TIME_TEXT, &itemType, &itemHandle, &itemRect);
			SetIText(itemHandle, timeStr);
		}
	}
	switch (theEvent->what)
	{
		case keyDown :	
		case autoKey :
			character = theEvent->message & charCodeMask;
			if(character == 0x03 || character == 0x0D)
			{
				*itemHit = TRUE;
				return(TRUE);
			}
			else
				return(FALSE);
			break;
		default:
			return(FALSE);
			break;
	}
}

int	
HandlePhaseDialog(void)
{
	short	itemType;
	Handle	itemHandle;
	Rect	itemRect;
	long	shift;
	short	itemHit, dialogDone = FALSE;
	Str255	shiftStr;
	
	shift = 1L;
	GetDItem(gPhaseDialog, PH_FIELD, &itemType, &itemHandle, &itemRect);
	SetIText(itemHandle, "\p1");
	SelectWindow(gPhaseDialog);
	DrawDialog(gPhaseDialog);
	ShowWindow(gPhaseDialog);
	DrawOKOutline(gPhaseDialog);
	while(dialogDone == FALSE)
	{
		ModalDialog(NIL_POINTER,&itemHit);
		switch(itemHit)
		{
			case PH_OK_BUTTON:
				HideWindow(gPhaseDialog);
				dialogDone = TRUE;
				return((int)shift);
				break;
			case PH_CANCEL_BUTTON:
				HideWindow(gPhaseDialog);
				dialogDone = TRUE;
				return(0);
				break;
			case PH_FIELD:
				GetDItem(gPhaseDialog,PH_FIELD, &itemType, &itemHandle, &itemRect);
				GetIText(itemHandle,shiftStr);
				StringToNum(shiftStr, &shift);
				if(shift < 0 || shift > 399)
				{
					shift = 1L;
					NumToString(shift, shiftStr);
					SetIText(itemHandle,shiftStr);
				}
				break;
			default:
				break;
		}
	}
}

double
HandleSetAllDialog()
{
	short		itemType, itemHit;
	Handle	itemHandle;
	Rect	itemRect;
	int		dialogDone = FALSE;
	Str255	lengthStr;
	double	value;
	
	value = 1.0000;
	GetDItem(gSetAllDialog, S_VALUE_FIELD, &itemType, &itemHandle, &itemRect);
	SetIText(itemHandle, "\p1.000000");
	SelectWindow(gSetAllDialog);
	DrawDialog(gSetAllDialog);
	ShowWindow(gSetAllDialog);
	DrawOKOutline(gSetAllDialog);
	while(dialogDone == FALSE)
	{
		ModalDialog(NIL_POINTER,&itemHit);
		switch(itemHit)
		{
			case S_OK_BUTTON:
				HideWindow(gSetAllDialog);
				dialogDone = TRUE;
				return(value);
				break;
			case S_CANCEL_BUTTON:
				HideWindow(gSetAllDialog);
				dialogDone = TRUE;
				break;
			case S_VALUE_FIELD:
				GetDItem(gSetAllDialog,S_VALUE_FIELD, &itemType, &itemHandle, &itemRect);
				GetIText(itemHandle,lengthStr);
				StringToFix(lengthStr, &value);
				break;
			default:
				break;
		}
	}
}
