/* 
 * CornBucket - a little asynchronous granular synthesis score generator, I am deeply indebted to Curtis
 * Roads article in "Representations of Musical Signals", (one of the best new books on computer
 * music!) "Asynchronous Granular Synthesis".
 *
 * Main.c - the realy boring stuff.
 *
 * Copyright 1994 Tom Erbe
 */
#if __MC68881__
#define __FASTMATH__
#define __HYBRIDMATH__
#endif	/* __MC68881__ */
#include <GestaltEqu.h>
#include "Dialog.h"
#include "Menu.h"
#include "CB.h"
#include <math.h>

#define	BASE_RES_ID			128
#define	MOVE_TO_FRONT		-1L
#define	REMOVE_ALL_EVENTS	0

#define	LEAVE_IT_WHERE_IT_IS	FALSE
#define	NORMAL_UPDATES			TRUE
 
/* Event Related Parameters */
#define	SLEEP				0L
#define	NIL_MOUSE_REGION	0L
#define	WNE_TRAP_NUM		0x60
#define	UNIMPL_TRAP_NUM		0x9F
#define	SUSPEND_RESUME_BIT	0x0001
#define	ACTIVATING			1
#define	RESUMING			1

/* Window display parameters */
#define	DRAG_THRESHOLD		30
#define	MIN_WINDOW_HEIGHT	50
#define	MIN_WINDOW_WIDTH	50

#define	MARK_APPLICATION	1

#define	SYS_VERSION			1

/* global variables */
DialogPtr	gAboutDialog, gErrorDialog, gCBDialog, gLengthDialog, gFunctionDialog,
			gPhaseDialog, gSetAllDialog;
WindowPtr	gNoteWindow;
EventRecord	gTheEvent;
MenuHandle	gAppleMenu, gFileMenu, gEditMenu;
NMRec		gMyNMRec;
Rect		gDragRect, gSizeRect;
RgnHandle	gNoteRegion;
StringHandle	gNotifyStrH;

Boolean		gDone, gWNEImplemented, gHasGestalt, gKeyDown, gMakingNotes;
int			gMaxRow, gCurRow, gFileNum;
short		gAppFileNum;
long		gSoundEnviron;
float		gTwoPi;
extern double	gLengthGrain;

#ifdef powerc
ModalFilterUPP		gDrawTrackFilter;
#endif

void
main() 
{
	ToolBoxInit();
	gAppFileNum = CurResFile();
	SetUpDragRect();
	SetUpSizeRect();
	MenuBarInit();
	DialogInit();
	MaxApplZone();
#ifdef powerc
	RoutineDesInit();
#endif
	GlobalInit();
	if(CapabilityCheck())
		MainLoop();
}

void
ToolBoxInit()
{
	InitGraf(&(qd.thePort));
	InitFonts();
	FlushEvents(everyEvent, REMOVE_ALL_EVENTS);
	InitWindows();
	InitMenus();
	TEInit();
	InitDialogs(NIL_POINTER);
	InitCursor();
}

Boolean
CapabilityCheck()
{
	OSErr	status;
	SysEnvRec	SysEnvData;
	long		response;
	Str255		errStr;
	
#ifdef powerc
	return(TRUE);
#endif
//	status = Gestalt(gestaltFPUType, &response);
//	if(response == 0L)
//	{
//		StopAlert(NO_FPU_ALERT, NIL_POINTER);
//		return(FALSE);
//	}
	status = Gestalt(gestaltProcessorType, &response);
	if(response < 3L)
	{
		StopAlert(NO_FPU_ALERT, NIL_POINTER);
		return(FALSE);
	}
	status = Gestalt(gestaltSystemVersion, &response);
	if((status!=noErr)||(response<0x0604))
	{
		StopAlert(BAD_SYS_ALERT, NIL_POINTER);
		return(FALSE);
	}
	else
		return(TRUE);
}

void
DialogInit()
{
	gAboutDialog = GetNewDialog(ABOUT_DLOG,NIL_POINTER,(WindowPtr)MOVE_TO_FRONT);
	gErrorDialog = GetNewDialog(ERROR_DLOG,NIL_POINTER,(WindowPtr)MOVE_TO_FRONT);
	gCBDialog = GetNewDialog(CB_DLOG,NIL_POINTER,(WindowPtr)MOVE_TO_FRONT);
	gLengthDialog = GetNewDialog(LENGTH_DLOG,NIL_POINTER,(WindowPtr)MOVE_TO_FRONT);
	gFunctionDialog = GetNewDialog(DRAWFUNC_DLOG,NIL_POINTER,(WindowPtr)MOVE_TO_FRONT);
	gPhaseDialog = GetNewDialog(PHASE_DLOG,NIL_POINTER,(WindowPtr)MOVE_TO_FRONT);
	gSetAllDialog = GetNewDialog(SETALL_DLOG,NIL_POINTER,(WindowPtr)MOVE_TO_FRONT);
}

void
MenuBarInit()
{
	Handle	myMenuBar;
	
	myMenuBar = GetNewMBar(BASE_RES_ID);
	SetMenuBar(myMenuBar);
	gAppleMenu = GetMHandle(APPLE_MENU_ID);
	gFileMenu = GetMHandle(FILE_MENU_ID);
	gEditMenu = GetMHandle(EDIT_MENU_ID);
	AddResMenu(gAppleMenu, 'DRVR');
	DrawMenuBar();
}

#ifdef powerc
void
RoutineDesInit(void)
{
	gDrawTrackFilter = NewRoutineDescriptor((ProcPtr)DrawTrackFilter, uppModalFilterProcInfo, GetCurrentISA());
}
#endif

void
SetUpDragRect(void)
{
	gDragRect = qd.screenBits.bounds;
	gDragRect.left += DRAG_THRESHOLD;
	gDragRect.right -= DRAG_THRESHOLD;
	gDragRect.bottom -= DRAG_THRESHOLD;
}

void
SetUpSizeRect(void)
{
	gSizeRect.top = MIN_WINDOW_HEIGHT;
	gSizeRect.left = MIN_WINDOW_WIDTH;
	gSizeRect.bottom = qd.screenBits.bounds.bottom - qd.screenBits.bounds.top;
	gSizeRect.right = qd.screenBits.bounds.right - qd.screenBits.bounds.left;
}

void
GlobalInit()
{
	/* Set up common variables */
	gDone = FALSE;
	gMakingNotes = FALSE;
	gKeyDown = TRUE;
	gTwoPi = 8.0 * atan(1.0);
	gNoteWindow = GetNewWindow(NOTE_WIND,NIL_POINTER,(WindowPtr)MOVE_TO_FRONT);
	gNoteRegion = NewRgn();
}

void
MainLoop()
{
	gWNEImplemented = (NGetTrapAddress(WNE_TRAP_NUM, ToolTrap) != 
						NGetTrapAddress(UNIMPL_TRAP_NUM, ToolTrap));
	while(gDone == FALSE)
		HandleEvent();
}

void
HandleEvent()
{
	char	theChar;
	
	if(gWNEImplemented)
	WaitNextEvent(everyEvent, &gTheEvent, SLEEP, NIL_MOUSE_REGION);
	else
	{
		SystemTask();
		GetNextEvent(everyEvent, &gTheEvent);
	}
	
	switch(gTheEvent.what)
	{
		case nullEvent:
			if(gMakingNotes)
				MakeANote();
			break;
		case mouseDown:
			HandleMouseDown();
			break;
		case keyDown:
		case autoKey:
			theChar = gTheEvent.message & charCodeMask;
			if (( gTheEvent.modifiers & cmdKey) != 0)
				HandleMenuChoice(MenuKey(theChar));
			else
				gKeyDown = TRUE;
			break;
		case updateEvt:
			BeginUpdate((WindowPtr)gTheEvent.message);
			EndUpdate((WindowPtr)gTheEvent.message);
			break;
		default:
			break;
	}
}

void
HandleMouseDown()
{
	WindowPtr	whichWindow;
	short		thePart;
	long		menuChoice, windSize;
	GrafPtr		oldPort;
	
	thePart = FindWindow(gTheEvent.where, &whichWindow);
	switch(thePart)
	{
		case inMenuBar:
			menuChoice = MenuSelect(gTheEvent.where);
			HandleMenuChoice(menuChoice);
			break;
		case inSysWindow:
			SystemClick(&gTheEvent,whichWindow);
			break;
		case inDrag:
			DragWindow(whichWindow,gTheEvent.where,&gDragRect);
			break;
		case inGoAway:
			HideWindow(whichWindow);
			break;
		case inGrow:
			windSize = GrowWindow(whichWindow,gTheEvent.where,&gSizeRect);
			if (windSize != 0)
			{
				GetPort(&oldPort);
				SetPort(whichWindow);
				EraseRect(&whichWindow->portRect);
				SizeWindow(whichWindow,LoWord(windSize),HiWord(windSize),NORMAL_UPDATES);
				InvalRect(&whichWindow->portRect);
				SetPort(oldPort);
			}
			break;
		case inContent:
			SelectWindow(whichWindow);
			break;
		case inZoomIn:
		case inZoomOut:
			if (TrackBox(whichWindow,gTheEvent.where,thePart))
			{
				GetPort(&oldPort);
				SetPort(whichWindow);				
				EraseRect(&whichWindow->portRect);
				ZoomWindow(whichWindow,thePart,LEAVE_IT_WHERE_IT_IS);
				InvalRect(&whichWindow->portRect);
				SetPort(oldPort);
			}
			break;
	}
}

void
HandleMenuChoice(menuChoice)
long menuChoice;
{
	int	theMenu;
	int theItem;
	
	if(menuChoice != 0)
	{
		theMenu = HiWord(menuChoice);
		theItem = LoWord(menuChoice);
		switch(theMenu)
		{
			case APPLE_MENU_ID:
				HandleAppleChoice(theItem);
				break;
			case FILE_MENU_ID:
				HandleFileChoice(theItem);
				break;
			case EDIT_MENU_ID:
				HandleEditChoice(theItem);
				break;
		}
		HiliteMenu(0);
	}
}

void	
HandleAppleChoice(theItem)
int	 theItem;
{
	Str255	accName;
	int		accNumber;
	short	itemNumber;
	
	switch	(theItem)
	{
		case ABOUT_ITEM:
			HandleAboutDialog();
			break;
		default:
			GetItem(gAppleMenu,theItem,accName);
			accNumber = OpenDeskAcc(accName);
			break;
	}
}

void
HandleFileChoice(theItem)
int	theItem;
{
	switch(theItem)
	{
		case OPEN_ITEM:
			HandleLengthDialog();
			break;
		case QUIT_ITEM:
			gDone = TRUE;
			break;
	}
}

void
HandleEditChoice(theItem)
int	theItem;
{
	switch(theItem)
	{
		case UNDO_ITEM:
			break;
		case CUT_ITEM:
			break;
		case COPY_ITEM:
			break;
		case PASTE_ITEM:
			break;
	}
}